import 'package:analyzer/dart/element/element.dart';
import 'package:analyzer/dart/element/visitor.dart';

import 'annotations.dart';

class AnnotatedMethodVisitor<T> extends SimpleElementVisitor<void> {
	final bool Function(MethodElement method) addMethod;

	AnnotatedMethodVisitor(this.addMethod);

	@override
	void visitMethodElement(final MethodElement element) {
		if (isAnnotatedWith(element, T)) {
			this.addMethod(element);
		}
	}

}
