import 'package:analyzer/dart/element/element.dart';
import 'package:b_generator/src/helpers/parameters.dart';

String linkedConstructor(final Element element, final Iterable<VariableElement> parameters) {
  return '${element.name}(${parameters.map((e) => 'this.${e.name}').join(', ')});';
}

String linkedConstructorByString(final String name, final Iterable<VariableElement> parameters) {
  return '$name(${parameters.map((e) => 'this.${e.name}').join(', ')});';
}

String constructor(final Element element, final Iterable<VariableElement> parameters) {
  return '${element.name}(${parameterSignature(parameters)});';
}

String constructorByString(final String name, final Iterable<VariableElement> parameters) {
  return '$name(${parameterSignature(parameters)});';
}
